/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.viewer.service;

import java.util.Collection;

import org.appspy.server.bo.Application;
import org.appspy.server.bo.ApplicationVersion;
import org.appspy.server.bo.Environment;
import org.appspy.server.bo.Host;
import org.appspy.server.bo.Organization;



/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface SettingsService {
	
	public Environment createEnvironment(Environment env);
	
	public Environment updateEnvironment(Environment env);

	public void deleteEnvironment(Environment env);
	
	public Collection<Environment> getEnvironments();
	
	public Organization createOrganization(Organization org);
	
	public Organization updateOrganization(Organization org);
	
	public void deleteOrganization(Organization org);
	
	public Collection<Organization> getOrganizations();
	
	public void deleteHost(Host host);
	
	public Host createHost(Host host);
	
	public Host updateHost(Host host);
	
	public Collection<Host> getHosts();
	
	public void deleteApplication(Application app);
	
	public Application createApplication(Application app);
	
	public Application updateApplication(Application app);
	
	public Collection<Application> getApplications();
	
	public void deleteVersion(ApplicationVersion ver);
	
	public ApplicationVersion createVersion(ApplicationVersion ver);
	
	public ApplicationVersion updateVersion(ApplicationVersion ver);
	
	public Collection<ApplicationVersion> getVersions();
}
